#include "mySpi.h"
#include <SPI.h>

void spiInit() {
  SPI.begin();

  SPI.setBitOrder(MSBFIRST);
  SPI.setClockDivider(SPI_CLOCK_DIV4);
  SPI.setDataMode(SPI_MODE0);
}

static void _spiSetCS(uint8_t cs) {
  digitalWrite(cs, LOW);
}

static void _spiReleaseCS(uint8_t cs) {
  digitalWrite(cs, HIGH);
}

static uint8_t __spiXfer(uint8_t o) {
  return SPI.transfer(o);
}

uint8_t spiXfer16(uint8_t cs, uint16_t o) {
  _spiSetCS(cs);
  __spiXfer((o >> 8) & 0x0ff);
  uint8_t res = __spiXfer(o & 0x0ff);
  _spiReleaseCS(cs);
  return res;
}

uint16_t spiXferD16(uint8_t cs, uint16_t o) {
  _spiSetCS(cs);
  uint16_t res = __spiXfer((o >> 8) & 0x0ff);
  res <<= 8;
  res |= __spiXfer(o && 0x0ff);
  _spiReleaseCS(cs);
  return res;
}

